class cbg_Mut1 extends Mutator;

var name WeaponName, AmmoName;
var string WeaponString, AmmoString;

function AddMutator(Mutator M)
{
	if ( M.IsA('Arena') )
	{
		log(M$" not allowed (already have an Arena mutator)");
		return; //only allow one arena mutator
	}
	Super.AddMutator(M);
}

//ripped from allweapons.u
function ModifyPlayer(Pawn Other)
{
	//log("cbg_Mut1: ModifyPlayer"@Other);

	GiveWeapon( Other, "t2.cbg" );

	if ( NextMutator != None )
		NextMutator.ModifyPlayer(Other);
}

function GiveWeapon(Pawn PlayerPawn, string aClassName )
{
	local class<Weapon> WeaponClass;
	local Weapon NewWeapon;

	WeaponClass = class<Weapon>(DynamicLoadObject(aClassName, class'Class'));

	if( PlayerPawn.FindInventoryType(WeaponClass) != None )
		return;
	newWeapon = Spawn(WeaponClass);
	if( newWeapon != None )
	{
		newWeapon.RespawnTime = 0.0;
		newWeapon.GiveTo(PlayerPawn);
		newWeapon.bHeldItem = true;
		newWeapon.GiveAmmo(PlayerPawn);
		newWeapon.SetSwitchPriority(PlayerPawn);
		newWeapon.WeaponSet(PlayerPawn);
		newWeapon.AmbientGlow = 0;
		if ( PlayerPawn.IsA('PlayerPawn') )
			newWeapon.SetHand(PlayerPawn(PlayerPawn).Handedness);
		else
			newWeapon.GotoState('Idle');
		PlayerPawn.Weapon.GotoState('DownWeapon');
		PlayerPawn.PendingWeapon = None;
		PlayerPawn.Weapon = newWeapon;
	}
}

/*
function bool AlwaysKeep(Actor Other)
{
	local bool bTemp;

	if ( Other.IsA(WeaponName) )
	{
		Weapon(Other).PickupAmmoCount = Weapon(Other).AmmoName.Default.MaxAmmo;
		return true;
	}
	if ( Other.IsA(AmmoName) )
	{
		Ammo(Other).AmmoAmount = Ammo(Other).MaxAmmo;
		return true;
	}

	if ( NextMutator != None )
		return ( NextMutator.AlwaysKeep(Other) );
	return false;
}*/

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	//log("cbg_Mut1: CheckReplacement"@Other);

	if ( Other.IsA('Weapon') && !Other.IsA(WeaponName) )
	{
		return false;
	}

	if ( Other.IsA('Pickup') && !Other.IsA(AmmoName) && !Other.IsA('UT_Jumpboots') )
	{
		return false;
	}

	bSuperRelevant = 0;
	return true;
}

defaultproperties
{
	WeaponName=cbg
	AmmoName=cbgcore
	WeaponString="t2.cbg"
	AmmoString="t2.cbgcore"
	DefaultWeapon=class't2.cbg'
}